<?php
function get_msgs() {
	$msgs = array();
	foreach (glob(sapp_include_path() . 'locale.*.php') AS $locale_filepath)
		include_once($locale_filepath);
	return $msgs;
}

function get_lang()
{
        return array(
                        'de' => msg('lang_de'),
                        'br' => msg('lang_br'),
                        'en' => msg('lang_en'),
                        'fr' => msg('lang_fr'),
                        'nl' => msg('lang_nl'),
                        'pl' => msg('lang_pl'),
                        'pt' => msg('lang_pt'),
                        'ru' => msg('lang_ru'),
                        'sw' => msg('lang_sw')
        );
}

function get_color()
{
        return array(
                        'default'       => msg('color_default'),
                        'blue1'         => msg('color_blue1'),
                        'blue2'         => msg('color_blue2'),
                        'blue3'         => msg('color_blue3'),
                        'blue4'         => msg('color_blue4'),
                        'blue5'         => msg('color_blue5'),
                        'gold1'         => msg('color_gold1'),
                        'gold2'         => msg('color_gold2'),
                        'green'         => msg('color_green'),
                        'grey1'         => msg('color_grey1'),
                        'grey2'         => msg('color_grey2'),
                        'grey3'         => msg('color_grey3'),
                        'light1'        => msg('color_light1'),
                        'light2'        => msg('color_light2'),
                        'light3'        => msg('color_light3'),
                        'red'           => msg('color_red'),
                        'violet'        => msg('color_violet')
        );
}

function msg($name, $locale = null)
{
	static $msgs;
	static $def_locale;

	if (!isset($msgs))
		$msgs = get_msgs();

	if (!isset($def_locale))
		$def_locale = $msgs['default'];

	if (null == $locale)
		$locale = sapp_get_locale();

	if (!isset($msgs[$locale]))
		$locale = $def_locale;

	if (isset($msgs[$locale][$name]))
		return $msgs[$locale][$name];
	elseif (isset($msgs[$def_locale][$name]))
		return $msgs[$def_locale][$name];
	else
		return $name;
}

function check_and_set_required($param_name, $additional_check = '') {
        $value = sapp_get_submit_value($param_name);
        // check that required parameter is set
        if (!isset($value)) {
                sapp_set_wrong($param_name);
                return false;
        }
        // parameter is specifyed - save it's value anyway
        sapp_set_param($param_name, $value);
        // check parameter's validity if validity-checking function is specifyed
        if ($additional_check !== '') {
                // check for validity-checking function existence
                if (!function_exists($additional_check)) {
                        sapp_set_errormsg('Can\'t check parameter\'s "' . $param_name . '" validity: function "' . $additional_check . '" doesn\'t exist');
                        sapp_set_wrong($param_name);
                        return false;
                }
                // check parameter's validity
                if (!$additional_check($value)) {
                        sapp_set_wrong($param_name, msg('invalid_value'));
                        return false;
                }
        }
        // all checks done, parameter is specifyed and seems to be correct
        return true;
}

function check_and_set_optional($param_name, $additional_check = '') {
        $value = sapp_get_param($param_name);
        if (!isset($value)) {
                sapp_set_param($param_name, NULL);
                return true;
        }
        sapp_set_param($param_name, $value);
        if ($additional_check !== '') {
                // check for validity-checking function existence
                if (!function_exists($additional_check)) {
                        sapp_set_errormsg('Can\'t check parameter\'s "' . $param_name . '" validity: function "' . $additional_check . '" doesn\'t exist');
                        sapp_set_wrong($param_name);
                        return false;
                }
                // check parameter's validity
                if (!$additional_check($value)) {
                        sapp_set_wrong($param_name);
                        return false;
                }
        }
        return true;
}

?>