<?PHP
sapp_include_once('common.php');

function form_handler() {

	$valid_required = true;

	/*******************************
	 *
	 *	Required parameters
	 *
	 *******************************/

	if (null === ($gtchat_admin_confirm = sapp_get_submit_value('gtchat_admin_confirm')))
		$gtchat_admin_confirm = '';

	if (null === ($gtchat_admin_passwd = sapp_get_submit_value('gtchat_admin_passwd'))) {
		$gtchat_admin_passwd = '';
		sapp_set_wrong('gtchat_admin_passwd', msg('password__empty'));
		$valid_required = false;
	} else if (!check_sys_passwd('admin', $gtchat_admin_passwd)) {
		sapp_set_wrong('gtchat_admin_passwd', msg('invalid_value'));
		$valid_required = false;
	}

	sapp_set_param('gtchat_admin_passwd', $gtchat_admin_passwd);
	sapp_set_param('gtchat_admin_confirm', $gtchat_admin_confirm);
	if ($gtchat_admin_passwd != $gtchat_admin_confirm) {
		sapp_set_wrong('gtchat_admin_passwd', msg('password__not_match'));
		$valid_required = false;
		sapp_set_param('gtchat_admin_confirm', '');
	}

	$email = sapp_get_param('gtchat_admin_email');
	$valid_required &= check_and_set_required('gtchat_admin_email', 'check_email');

	$valid_required &= check_and_set_required('gtchat_language');
	$valid_required &= check_and_set_required('gtchat_colorscheme');
	$valid_required &= check_and_set_required('gtchat_welcome_message');

	if (!$valid_required) {
		sapp_set_error(msg('some_parameters_are_wrong'));
		// return the current step number
		return 1;
	}

	// return the next step number
	return 2;
}
?>
